// Módulo: system
// Descripción: Control de barrera con temporizador
// Proyecto: Sistema de control de una barrera
// Autor: Jorge Juan-Chico <jjchico@dte.us.es>
// Modificado añadiendo comentarios y esqueleto de las insatancias 23-02-2024
// Copyright Universidad de Sevilla, Spain
// Fecha original: 21-02-2019

module system #(
    parameter SYS_FREQ = 50000000   // frecuencia de reloj del sistema (Hz)
    )(
    input wire clk,         // reloj del sistema
    input wire reset,       // puesta a cero del sistema
    input wire open,        // señal de apertura (activa en alto)
    output wire gate,       // salida de control (0-cerrar, 1-abrir)
    output wire servo       // salida de control del servo
    );

    
	//cables de interconexión entre módulos:
    wire eoc;       // fin de cuenta del temporizador
    wire clear;     // puesta a cero del contador
    wire enable;    // habilitación del temporizador

    /*** instancias y conexión de los módulos: control, timer, servo_gate ***/
	
	// aquí se instancia el módulo servo_gate
    servo_gate #(.FS(SYS_FREQ)) servo_gate (
		.clk(clk),
		.gate(gate),
		.servo(servo)
        // .finished(finished) // sin conectar (todavía)
        );
		
	// aquí se instancia el módulo control
	timer #(.SYS_FREQ(SYS_FREQ)) inst_timer (
		//completar
		);	
				
	// aquí se instancia el módulo timer
	control inst_control (
        //completar
        );
	
endmodule // system
